<?php
/*!*******************************************************************************
*! FILE NAME  : compass.php
*! DESCRIPTION: Reads Heading, Roll, Pitch from the Honeywell HMR3000 compass
*!              module attached to the serial port of the Elphel model 353 camera
*!              Requires 10349/10369 boards with extra connection to +5V
*!              (on 10369 can use 4-pin RJ45 sync out as power).
*!              Needs system to be configured with the debug port disabled.
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!
*!  $Log: compass_os5000.php,v $
*!  Revision 1.1.1.1  2008/11/27 20:04:01  elphel
*!
*!
*!  Revision 1.1  2008/04/07 09:17:01  elphel
*!  manual interface to compass modules
*!
*!  Revision 1.1  2008/03/23 20:13:47  elphel
*!  added support for the Honeywell HMR3000 compass module attached to the serial port.
*!
*!
*/
	// command code and value come with no spaces
	// example: "http://192.168.1.75/var/compass.php?*1", * - command, 1 - value
	$ser_port="/dev/ttyUSB0";

	$xml = new SimpleXMLElement("<?xml version='1.0'?><hpr/>");
	
	$s=str_split($_SERVER["QUERY_STRING"]);

	for ($i=1; $i<sizeof($s); $i++) {
		$s1.= $s[$i];
	}
	
	exec ("stty -F $ser_port onlcr -echo speed 19200");

	$sero=fopen($ser_port,"w");
	$seri=fopen($ser_port,"r");

	$n=fwrite($sero,chr(27).$s[0]."\n");// chr(27) - ESC character, $s[0] - command,"\n" - <enter> 
	$response=fgets($seri);             // here the compass writes "enter value or esc"
	$n=fwrite($sero,"$s1\n");           // command value is written

	for ($i=0; $i<3; $i++) {
		fgets($seri);
		$response.="; ".fgets($seri);
	}

	fclose ($sero);
	fclose ($seri);

  $xml->addChild ('raw',$response);
  
  $rslt=$xml->asXML();
  header("Content-Type: text/xml");
  header("Content-Length: ".strlen($rslt)."\n");
  header("Pragma: no-cache\n");
  printf($rslt);
?>
 
