<?php
/*!***************************************************************************
*! FILE NAME  : mem_test.php
*! DESCRIPTION: tests DDR memory on the 10359 board
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: mem_test.php,v $
*!  Revision 1.1.1.1  2008/11/27 20:04:02  elphel
*!
*!
*!  Revision 1.2  2008/05/01 20:27:08  dzhimiev
*!  reformatted a little
*!
*!  Revision 1.1  2008/04/23 01:55:49  dzhimiev
*!  1. added x359 files to src lists
*!  2. x359 read/write DDR
*!  3. x359 3 channels mux directly to out
*!  4. x359 one channel through DDR and another directly frames switching at out
*!
*/

function send_i2c($a,$d) {
	$i2c  = fopen('/dev/xi2c16','w');
	fseek ($i2c, 2*$a);
	$res=fwrite($i2c, chr (floor($d/256)).chr ($d-256*floor($d/256)));
	fclose($i2c);
	return $res;
}

function receive_i2c($a) {
	$i2c  = fopen('/dev/xi2c16','r');
	fseek ($i2c, 2*$a);
	$data = fread($i2c, 2);
	fclose($i2c);
	if (strlen($data)<2) return -1;
	$v=unpack('n1',$data);
	return $v[1];
}

function receive_i2c_4($width,$bus,$a,$raw=0) {
   $w=($width==16)?2:1;
   $i2c_fn='/dev/xi2c'.($raw?'raw':(($w==2)?'16':'8')).(($bus==0)?'':'_aux');
   $i2c  = fopen($i2c_fn, 'r');
	 fseek ($i2c, 4, SEEK_END);
   fseek ($i2c, $w*$a);
	 
   $data = fread($i2c, 2*$w);
   fclose($i2c);
   if (strlen($data)<2*$w) return -1;
   $v=unpack(($w==1)?'C*':'N*',$data);
	 //print_r($v);
	 //printf("0x%x\n",$v[1]);
	 return $v[1];
} // end of receive_i2c()

function receive_i2c_n($width,$bus,$a,$raw=0) {
   $w=($width==16)?2:1;
   $i2c_fn='/dev/xi2c'.($raw?'raw':(($w==2)?'16':'8')).(($bus==0)?'':'_aux');
   $i2c  = fopen($i2c_fn, 'r');
	 fseek ($i2c, 16*4, SEEK_END);
   fseek ($i2c, $w*$a);
	 
   $data = fread($i2c, 2*$w*4*4);
   fclose($i2c);
   if (strlen($data)<2*$w) return -1;
   $v=unpack(($w==1)?'C*':'N*',$data);
	 //print_r($v);
	 //printf("0x%x\n",$v[1]);
	 return array($v[1],$v[2],$v[3],$v[4],$v[5],$v[6],$v[7],$v[8],$v[9],$v[10],$v[11],$v[12],$v[13],$v[14],$v[15],$v[16]);
} // end of receive_i2c()

function send_i2c_4($width,$bus,$a,$d,$raw=0) { //$a<0 - use raw read/write
   $w=($width==16)?2:1;
   $i2c_fn='/dev/xi2c'.($raw?'raw':(($w==2)?'16':'8')).(($bus==0)?'':'_aux');
   $i2c  = fopen($i2c_fn, 'w');
   fseek ($i2c, $w*$a) ;
   if ($w==1)    $res=fwrite($i2c, chr ($d));
   else          $res=fwrite($i2c, chr (floor($d/(256*256*256))).chr (($d - 256*256*256*floor($d/(256*256*256)))/(256*256)).chr (($d - 256*256*floor($d/(256*256)))/256).chr ($d - 256*floor($d/(256))) );

	 //printf("Sending passage ");
	 printf("0x%08x ",$d);	
	 //printf("\n");

   fclose($i2c);
   return $res;
} // end of send_i2c()

function send_i2c_4a($width,$bus,$a,$d,$raw=0) { //$a<0 - use raw read/write
   $w=($width==16)?2:1;
   $i2c_fn='/dev/xi2c'.($raw?'raw':(($w==2)?'16':'8')).(($bus==0)?'':'_aux');
   $i2c  = fopen($i2c_fn, 'w');
   fseek ($i2c, $w*$a) ;
   if ($w==1)    $res=fwrite($i2c, chr ($d));
   else          $res=fwrite($i2c, chr (floor($d/(256*256*256))).chr (($d - 256*256*256*floor($d/(256*256*256)))/(256*256)).chr (($d - 256*256*floor($d/(256*256)))/256).chr ($d - 256*floor($d/(256))) );

	 //printf("Sending passage ");
	 printf("%08d ",$d);	 
	 //printf("\n");

   fclose($i2c);
   return $res;
} // end of send_i2c()

function send_i2c_4_nc($a,$d) {
	$i2c  = fopen('/dev/xi2c16','w');
	fseek ($i2c, 2*$a) ;
	$res=fwrite($i2c, chr (floor($d/(256*256*256))).chr (($d - 256*256*256*floor($d/(256*256*256)))/(256*256)).chr (($d - 256*256*floor($d/(256*256)))/256).chr ($d - 256*floor($d/(256))) );
	fclose($i2c);
	return $res;
} 

function dcm_reset($width,$bus,$raw=0){

	printf("sent 0x%04x ",0x0810); send_i2c_4($width,$bus,0x0810,0xffffffff,$raw=0);
	printf("\nsent 0x%04x ",0x0810); send_i2c_4($width,$bus,0x0810,0x00000000,$raw=0);
	
}

function ramb_check($width,$bus,$raw=0){
	printf("Data sent:     ");

	send_i2c_4($width,0,0x0801,0x01020343,$raw=0);
	send_i2c_4($width,0,0x0801,0x05060787,$raw=0);
	send_i2c_4($width,0,0x0801,0x090a0bcb,$raw=0);
	send_i2c_4($width,0,0x0801,0x0d0e0f0f,$raw=0);

	send_i2c_4($width,$bus,0x0801,0x11121314,$raw=0);
	send_i2c_4($width,$bus,0x0801,0x15161718,$raw=0);
	send_i2c_4($width,$bus,0x0801,0x191a1b1c,$raw=0);
	send_i2c_4($width,$bus,0x0801,0x1d1e1f20,$raw=0);

	send_i2c_4($width,$bus,0x0801,0x21222324,$raw=0);
	send_i2c_4($width,$bus,0x0801,0x25262728,$raw=0);
	send_i2c_4($width,$bus,0x0801,0x292a2b2c,$raw=0);
	send_i2c_4($width,$bus,0x0801,0x2d2e2f30,$raw=0);

	send_i2c_4($width,$bus,0x0801,0x31323334,$raw=0);
	send_i2c_4($width,$bus,0x0801,0x35363738,$raw=0);
	send_i2c_4($width,$bus,0x0801,0x393a3b3c,$raw=0);
	send_i2c_4($width,$bus,0x0801,0x3d3e3f40,$raw=0);

	printf("\nData received: ");
	for ($i=0;$i<16;$i++)
	{
		$data=receive_i2c_4($width,$bus,0x0868,$raw=0); // first try to read 4
		printf("0x%08x ",$data);// 0x%x",$data[2]);
	}
}

function ddr_init($width,$bus,$raw=0){

	printf("sent 0x%04x ",0x0827); send_i2c_4($width,$bus,0x0827,0x00000000,$raw=0); printf("\n");

	printf("sent 0x%04x ",0x0823); send_i2c_4($width,$bus,0x0823,0x00017fff,$raw=0); 

	$data=receive_i2c_4($width,$bus,0x0841,$raw=0); 
	printf("read 0x%04x 0x%08x\n",0x0841,$data);

	printf("sent 0x%04x ",0x0823); send_i2c_4($width,$bus,0x0823,0x00002002,$raw=0); 

	$data=receive_i2c_4($width,$bus,0x0841,$raw=0); 
	printf("read 0x%04x 0x%08x\n",0x0841,$data);

	printf("sent 0x%04x ",0x0823); send_i2c_4($width,$bus,0x0823,0x00000163,$raw=0); 

	$data=receive_i2c_4($width,$bus,0x0841,$raw=0); 
	printf("read 0x%04x 0x%08x\n",0x0841,$data);

	printf("sent 0x%04x ",0x0823); send_i2c_4($width,$bus,0x0823,0x00008000,$raw=0);

	$data=receive_i2c_4($width,$bus,0x0841,$raw=0); 
	printf("read 0x%04x 0x%08x\n",0x0841,$data);

	printf("sent 0x%04x ",0x0823); send_i2c_4($width,$bus,0x0823,0x00008000,$raw=0);

	$data=receive_i2c_4($width,$bus,0x0841,$raw=0); 
	printf("read 0x%04x 0x%08x\n",0x0841,$data);

	printf("sent 0x%04x ",0x0823); send_i2c_4($width,$bus,0x0823,0x00017fff,$raw=0); 

	$data=receive_i2c_4($width,$bus,0x0841,$raw=0);
	printf("read 0x%04x 0x%08x\n",0x0841,$data);

}

function ddr_page_write($width,$bus,$sa,$raw=0){

	send_i2c_4_nc(0x0827,0x00000000); // turn off channels
	send_i2c_4_nc(0x0827,0x00000001); // turn on auto refresh

	send_i2c_4_nc(0x082c,0x00004000+4*$sa); // set ch3 start addr
	send_i2c_4_nc(0x082d,0x000001f0); // set block size to write = 256 16-bit words
	//send_i2c_4_nc($width,$bus,0x082e,0x00000003,$raw=0); // number of blocks can be written
	//send_i2c_4_nc($width,$bus,0x082e,0x00000004,$raw=0); // number of blocks can be written
	send_i2c_4_nc(0x082e,0x00000003); // number of blocks can be written

	send_i2c_4_nc(0x0827,0x00000021); // turn on channel 3

	printf("Sent array to Row 0x%08x\n",$sa);

	printf("<font color=DARKBLUE>");

	$aha1=0;
	for($aha=0;$aha<512;$aha++){

		$aha2=$aha+0x00010000*$sa;

		printf("%08x ",$aha2);

		send_i2c_4_nc(0x0831,$aha2);
		
		if ($aha1==15) {$aha1=0; printf("\n");}
		else           {$aha1++;} 

	}

	printf("</font>");

	send_i2c_4_nc(0x0834,0x11223344); // write 256, 0x11223344 - means nothing
	send_i2c_4_nc(0x0834,0x11223344); // write 256, 0x11223344 - means nothing
	send_i2c_4_nc(0x0834,0x11223344); // write 256, 0x11223344 - means nothing
	send_i2c_4_nc(0x0834,0x11223344); printf("\n"); // write 256, 0x11223344 - means nothing

}

function ddr_page_read($width,$bus,$rra,$raw=0){
	//send_i2c_4_nc(0x0827,0x00000000); // turn off channels
	send_i2c_4_nc(0x0827,0x00000021); // turn on channel 3

	send_i2c_4_nc(0x082d,0x000001f0);
	send_i2c_4_nc(0x082e,0x00000003);
	
	printf("Acquired data from row 0x%08x\n",$rra);

	send_i2c_4_nc(0x082c,4*$rra);
	
	printf("<font color=\"#0000FF\">");
	for($g=0;$g<32;$g++){
		$data_array=receive_i2c_n($width,$bus,0x0833,$raw=0); // read page
		$j=0;
		
		for ($i=0,$index=count($data_array); $i<$index;$i++) 
		{
			printf("%08x ",$data_array[$i]);
			if ($j==15) {$j=0; printf("\n");}
			else        {$j++;              }
		}
	}
	printf("\n</font>");
}

  $width=16;
  $bus=0;
  $raw=0;

	$phase_shift=0;
	$row_adr=0x3ff;
	$N=0;
	$N_shifts=1;

	foreach($_GET as $key=>$value) {
		switch($key) {
			case "phase_shift": $phase_shift=$value+0; break;
			case "row_adr"    : $row_adr=$value+0;     break;
			case "N"          : $N=$value+0;           break;
			case "N_shifts"   : $N_shifts=$value+0;    break;
		}
	}

	printf("<pre>");

	$testing=46;
	


	if ($phase_shift==0) {
		printf("<h3>Reset DCM</h3>");
		dcm_reset($width,$bus,$raw=0);
	}else{
		printf("<h3>Phase Shift DCM</h3>");
		for($i=0;$i<$N_shifts;$i++){
			send_i2c_4($width,$bus,0x0808,$phase_shift,$raw=0);
			usleep(1);
		}
	}

	printf("<h3>RAMB & I2C test</h3>");
	ramb_check($width,$bus,$raw=0);

	printf("<h3>DDR Initialization sequence</h3>");
	ddr_init($width,$bus,$raw=0);

	printf("<h3>Write DDR</h3>");
	for($i=$row_adr;$i<$row_adr+$N;$i++){
		ddr_page_write($width,$bus,$i,$raw=0); // $rsa=
	}

	printf("<h3>Read DDR</h3>");
	for($i=$row_adr;$i<$row_adr+$N;$i++){
		ddr_page_read($width,$bus,$i,$raw=0); // $rsa=
	}
	printf("</pre>");

?>
