<?php
/*!***************************************************************************
*! FILE NAME  : reg_read.php
*! DESCRIPTION: reads some control and test registers of 10359 board
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: reg_read.php,v $
*!  Revision 1.1  2009/02/13 09:53:10  dzhimiev
*!  1. removed old scripts
*!  2. added new with registers reading and writing, phase shifting and programming other sensors of 10359
*!
*!  Revision 1.1  2008/04/23 01:55:50  dzhimiev
*!  1. added x359 files to src lists
*!  2. x359 read/write DDR
*!  3. x359 3 channels mux directly to out
*!  4. x359 one channel through DDR and another directly frames switching at out
*!
*/

require 'i2c.inc';

function receive_i2c_4($width,$bus,$a,$raw=0) {
   $w=($width==16)?2:1;
   $i2c_fn='/dev/xi2c'.($raw?'raw':(($w==2)?'16':'8')).(($bus==0)?'':'_aux');
   $i2c  = fopen($i2c_fn, 'r');
	 fseek ($i2c, 4, SEEK_END);
   fseek ($i2c, $w*$a);
	 
   $data = fread($i2c, 2*$w);
   fclose($i2c);
   if (strlen($data)<2*$w) return -1;
   $v=unpack(($w==1)?'C*':'N*',$data);
	 //print_r($v);
	 //printf("0x%x\n",$v[1]);
	 return $v[1];
} // end of receive_i2c()

function send_i2c_4($width,$bus,$a,$d,$raw=0) { //$a<0 - use raw read/write
   $w=($width==16)?2:1;
   $i2c_fn='/dev/xi2c'.($raw?'raw':(($w==2)?'16':'8')).(($bus==0)?'':'_aux');
   $i2c  = fopen($i2c_fn, 'w');
   fseek ($i2c, $w*$a) ;
   if ($w==1)    $res=fwrite($i2c, chr ($d));
   else          $res=fwrite($i2c, chr (floor($d/(256*256*256))).chr (($d - 256*256*256*floor($d/(256*256*256)))/(256*256)).chr (($d - 256*256*floor($d/(256*256)))/256).chr ($d - 256*floor($d/(256))) );

	 //printf("Sending passage ");
	 printf("0x%02x%02x%02x%02x ",(floor($d/(256*256*256))),(($d - 256*256*256*floor($d/(256*256*256)))/(256*256)),(($d - 256*256*floor($d/(256*256)))/256),($d - 256*floor($d/(256))));	 
	 //printf("\n");

   fclose($i2c);
   return $res;
} // end of send_i2c()

$width=16;
$bus=0;
$adr=0x0860;
$datax=5;
$nopars=false;
$raw=0;

$phase_shift=0;
$channel=2;
$lines=4;
$pixes=1619;
$delay=0x000fffff;
$sphase=0x00000007;
$ch1_ch2_delay=2;

printf("<pre><TITLE>Registers read</TITLE>");

	$adr=0x0800;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : Version <font size=\"6\">0x%08x</font>\n",$adr,$data);

	$adr=0x0801;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : Snapshot status is <font size=\"6\">0x%08x</font>\n  [3]-direct frame done,\n  [2]-buffered frame read out,\n  [1]-buffered frame in,\n  [0]-buffered frame 1st read out\n",$adr,$data);

	$adr=0x0802;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : mcontr enabled channels are <font size=\"6\">0x%08x</font>\n",$adr,$data);

	$adr=0x0803;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("<font color=blue>read 0x%04x : clk0 counter <font size=\"6\">0x%08x</font></font>\n",$adr,$data);

	$adr=0x0804;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : some data <font size=\"6\">0x%08x</font>\n",$adr,$data);

	$adr=0x0805;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : ch0 current address <font size=\"6\">0x%08x</font>\n",$adr,$data);

	$adr=0x0806;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : ch1 current address <font size=\"6\">0x%08x</font>\n",$adr,$data);

	$adr=0x0807;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : ch2 current address <font size=\"6\">0x%08x</font>\n",$adr,$data);

	$adr=0x0844;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : number of errors <font size=\"6\">0x%08x</font>\n",$adr,$data);

	$adr=0x0860;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : frame dimensions are <font size=\"6\">0x%08x</font>\n",$adr,$data);

	$adr=0x0861;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : DCM1 phase step number is <font size=\"6\">0x%08x</font>\n",$adr,$data);

	$adr=0x0862;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : DCM_S2 phase step number is <font size=\"6\">0x%08x</font>\n",$adr,$data);
	
	$adr=0x0863;
	$data=receive_i2c_4($width,$bus,$adr,$raw=0);
	printf("read 0x%04x : DCM_S3 phase step number is <font size=\"6\">0x%08x</font>\n",$adr,$data);


	printf("</pre>");

?>
