`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   21:02:26 04/01/2007
// Design Name:   x359
// Module Name:   /home/andrey/xil91/x359//x359_1.tf
// Project Name:  x359
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: x359
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module x359_tf;
   parameter DCLK_PER = 50;	//20MHz
   parameter I2C_PER = 1000;

	// Inputs
	reg SDNCLK_FB;
	reg SDCLK_FB;
	reg DCLK;
	reg MRST;
	reg ARO;
	reg ARST;
	reg PX_BPF1;
	reg PX_HACT1;
	reg PX_VACT1;
	reg PX_BPF2;
	reg PX_HACT2;
	reg PX_VACT2;
	reg PX_BPF3;
	reg PX_HACT3;
	reg PX_VACT3;

	// Outputs
	wire RUN;
	wire SDCLKE;
	wire SDCLK;
	wire SDNCLK;
	wire SDLDM;
	wire SDUDM;
	wire SDWE;
	wire SDCAS;
	wire SDRAS;
	wire [14:0] SDA;
	wire [9:0] PXD;
	wire BPF;
	wire HACT;
	wire VACT;
	wire PX_DCLK1;
	wire PX_MRST1;
	wire PX_ARO1;
	wire PX_ARST1;
	wire PX_DCLK2;
	wire PX_MRST2;
	wire PX_ARO2;
	wire PX_ARST2;
	wire PX_DCLK3;
	wire PX_MRST3;
	wire PX_ARO3;
	wire PX_ARST3;

	// Bidirs
	wire [15:0] SDD;
	wire UDQS;
	wire LDQS;
	wire SCL0;
	wire SDA0;
	wire CNVSYNC;
	wire CNVCLK;
	wire [11:0] PXD1;
	wire PX_SCL1;
	wire PX_SDA1;
	wire SENSPGM1;
	wire [11:0] PXD2;
	wire PX_SCL2;
	wire PX_SDA2;
	wire SENSPGM2;
	wire [11:0] PXD3;
	wire PX_SCL3;
	wire PX_SDA3;
	wire SENSPGM3;
	wire ALWAYS0;
   
// test registers/wires
   reg I2C_CLK;
   reg HOST_SDA;   
   reg HOST_SCL;   
   reg HOST_SDA_EN;   
   reg HOST_SCL_EN;   
   
   assign SDA0= HOST_SDA_EN ? HOST_SDA : 'bz;  
   assign SCL0= HOST_SCL_EN ? HOST_SCL : 'bz;  

	// Instantiate the Unit Under Test (UUT)
	x359 i_x359 (
		.RUN(RUN), 
		.SDCLKE(SDCLKE), 
		.SDNCLK_FB(SDNCLK_FB), 
		.SDCLK(SDCLK), 
		.SDNCLK(SDNCLK), 
		.SDCLK_FB(SDCLK_FB), 
		.SDLDM(SDLDM), 
		.SDUDM(SDUDM), 
		.SDWE(SDWE), 
		.SDCAS(SDCAS), 
		.SDRAS(SDRAS), 
		.SDA(SDA), 
		.SDD(SDD), 
		.UDQS(UDQS), 
		.LDQS(LDQS), 
		.PXD(PXD), 
		.DCLK(DCLK), 
		.BPF(BPF), 
		.HACT(HACT), 
		.VACT(VACT), 
		.MRST(MRST), 
		.ARO(ARO), 
		.ARST(ARST), 
		.SCL0(SCL0), 
		.SDA0(SDA0), 
		.CNVSYNC(CNVSYNC), 
		.CNVCLK(CNVCLK), 
		.PXD1(PXD1), 
		.PX_DCLK1(PX_DCLK1), 
		.PX_BPF1(PX_BPF1), 
		.PX_HACT1(PX_HACT1), 
		.PX_VACT1(PX_VACT1), 
		.PX_MRST1(PX_MRST1), 
		.PX_ARO1(PX_ARO1), 
		.PX_ARST1(PX_ARST1), 
		.PX_SCL1(PX_SCL1), 
		.PX_SDA1(PX_SDA1), 
		.SENSPGM1(SENSPGM1), 
		.PXD2(PXD2), 
		.PX_DCLK2(PX_DCLK2), 
		.PX_BPF2(PX_BPF2), 
		.PX_HACT2(PX_HACT2), 
		.PX_VACT2(PX_VACT2), 
		.PX_MRST2(PX_MRST2), 
		.PX_ARO2(PX_ARO2), 
		.PX_ARST2(PX_ARST2), 
		.PX_SCL2(PX_SCL2), 
		.PX_SDA2(PX_SDA2), 
		.SENSPGM2(SENSPGM2), 
		.PXD3(PXD3), 
		.PX_DCLK3(PX_DCLK3), 
		.PX_BPF3(PX_BPF3), 
		.PX_HACT3(PX_HACT3), 
		.PX_VACT3(PX_VACT3), 
		.PX_MRST3(PX_MRST3), 
		.PX_ARO3(PX_ARO3), 
		.PX_ARST3(PX_ARST3), 
		.PX_SCL3(PX_SCL3), 
		.PX_SDA3(PX_SDA3), 
		.SENSPGM3(SENSPGM3), 
		.ALWAYS0(ALWAYS0)
	);

	initial begin
		// Initialize Inputs
		SDNCLK_FB = 0;
		SDCLK_FB = 0;
		DCLK = 0;
		MRST = 0;
		ARO = 0;
		ARST = 0;
		PX_BPF1 = 0;
		PX_HACT1 = 0;
		PX_VACT1 = 0;
		PX_BPF2 = 0;
		PX_HACT2 = 0;
		PX_VACT2 = 0;
		PX_BPF3 = 0;
		PX_HACT3 = 0;
		PX_VACT3 = 0;

		// Wait 100 ns for global reset to finish
		#100;
        
		// Add stimulus here

	end
      
      
   always #(DCLK_PER/2)	DCLK =	   ~DCLK;
   always #(I2C_PER/2)	I2C_CLK =	~I2C_CLK;

//   parameter DCLK_PER = 50	//20MHz
//   parameter I2C_PER = 1000;
    	initial begin
    $dumpfile("x359.lxt");
    $dumpvars(0,x359_tf);
      DCLK = 0;
      I2C_CLK = 0;
// test registers/wires
      I2C_CLK =0;
      HOST_SDA=1;   
      HOST_SCL=1;   
      HOST_SDA_EN=0;
      HOST_SCL_EN=0;   
      
#1000;
		glbl.GSR_int = 1'b1;
		glbl.GTS_int = 1'b1;
		#2000;
		glbl.GSR_int = 1'b0;
		#20;
		glbl.GTS_int = 1'b0;
		#50;

#1000;

      i2c_start;
      i2c_sendbyte ('h10);
      i2c_sendbyte ('h01);
      i2c_sendbyte ('h12);
      i2c_sendbyte ('h35);
      i2c_sendbyte ('h56);
      i2c_sendbyte ('h78);
      i2c_stop;
#2000;
      i2c_start;
      i2c_sendbyte ('h10);
      i2c_sendbyte ('h01);
      i2c_restart;      
      i2c_sendbyte ('h11);
      i2c_readbyte (1);
      i2c_readbyte (1);
      i2c_readbyte (1);
      i2c_readbyte (0);
      i2c_stop;
#2000;
      i2c_start;
      i2c_sendbyte ('h10);
      i2c_sendbyte ('h01);
      i2c_sendbyte ('h12);
      i2c_sendbyte ('h34);
      i2c_sendbyte ('h56);
      i2c_sendbyte ('h78);
      i2c_stop;
#2000;
      $finish;

   end  
//   i2c_start;
//   i2c_stop;
//   i2c_restart;
//   i2c_sendbyte (byte);
//   i2c_readbyte (more);
      

//      HOST_SDA=1;   
//      HOST_SCL=1;   
//      HOST_SDA_EN=0;
//      HOST_SCL_EN=0;   
//   i2c_start;
//   i2c_stop;
//   i2c_restart;
//   i2c_sendbyte (byte);
//   i2c_readbyte (more);


parameter I2CDLY = 10;
   task i2c_start;  // SCL is supposed to be 1, SDA - released
     begin
       $display ("i2c START at %t", $time);
       HOST_SDA=1;
       HOST_SCL=1;
       HOST_SDA_EN=0;
       HOST_SCL_EN=1;
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SDA_EN=1;
       HOST_SDA=0;
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SCL=0;
     end
   endtask   

   task i2c_stop;  // SCL is supposed to be 0, SDA - any
     begin
       $display ("i2c STOP at %t", $time);
       HOST_SCL=0;
       HOST_SCL_EN=1;
       wait (~I2C_CLK);wait (I2C_CLK); // wait for bus turnover (it was likely reading ACKN)
       HOST_SDA=0;
       HOST_SDA_EN=1;
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SCL=1;
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SDA=1;
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SDA_EN=0;
     end
   endtask
   
   task i2c_restart;  // SCL is supposed to be 0, SDA - any
     begin
       $display ("i2c RESTART at %t", $time);
       HOST_SCL=0;
       HOST_SCL_EN=1;
       wait (~I2C_CLK);wait (I2C_CLK); // wait for bus turnover (it was likely reading ACKN)
       HOST_SDA=1;
       HOST_SDA_EN=1;
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SCL=1;
       HOST_SDA_EN=0;
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SDA=0;
       HOST_SDA_EN=1;
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SCL=0;
     end
   endtask

   task i2c_sendbyte;  // SCL is supposed to be 0, SDA - any
     input [7:0] b;
     reg ackn;
     integer i;
     begin
       $display ("i2c send (%x) at %t", b,$time);
       HOST_SCL=0;
       HOST_SCL_EN=1;
       wait (~I2C_CLK);wait (I2C_CLK); // wait for bus turnover (it was reading ACKN)
       for (i=7;i>=0;i=i-1) begin
//         # (I2CDLY);
         HOST_SDA=b[i];
         HOST_SDA_EN=1;
         wait (~I2C_CLK);wait (I2C_CLK);
         HOST_SCL=1;
         if (HOST_SDA) begin
           HOST_SDA_EN=0;
         end
         wait (~I2C_CLK);wait (I2C_CLK);
         HOST_SCL=0;
       end
       HOST_SDA_EN=0; // float for acknowledge
       wait (~I2C_CLK);wait (I2C_CLK);
       ackn=SDA0;
       #1;
       $display ("i2c acknowledge (%x)", ackn);
       HOST_SCL=1;
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SCL=0;
     end
   endtask   

   task i2c_readbyte;  // SCL is supposed to be 0, SDA - any (more)
     input more;
     reg [7:0] d;
     integer i;
     begin
       $display ("i2c read (more=%x) at %t", more, $time);
       HOST_SCL=0;
       HOST_SCL_EN=1;
       HOST_SDA_EN=0;
       for (i=7;i>=0;i=i-1) begin
         wait (~I2C_CLK);wait (I2C_CLK);
         d[i]=SDA0;
         #1;
         HOST_SCL=1;
         wait (~I2C_CLK);wait (I2C_CLK);
         HOST_SCL=0;
       end
//       # (I2CDLY);
       wait (~I2C_CLK);wait (I2C_CLK); // wait for bus turnover (it was reading)
       HOST_SDA=~more;
       HOST_SDA_EN=1; 
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SCL=1;
       if (HOST_SDA) begin
         HOST_SDA_EN=0;
       end
       wait (~I2C_CLK);wait (I2C_CLK);
       HOST_SCL=0;
       $display ("i2c read returned %x", d);
     end
   endtask   

endmodule

