#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#define GAMMA_FN	"gamma.dat"

/*
 * write in resulting file table in format:
 *
 * count: unsigned short
 *
 * gamma value [1]
 * scale value [256]
 * ...
 * value in format 0.00 - 1.0
 * as 0x0000 - 0xFFFF in fixed point format 0.16
 */

inline unsigned short float_to_fp(unsigned char *fp, float val) {
	unsigned long v;
	unsigned short r;

	if(val <= 0.0) {
		fp[0] = 0x00;
		fp[1] = 0x00;
		return 0x0000;
	}
	if(val >= 1.0) {
		fp[0] = 0xFF;
		fp[1] = 0xFF;
		return 0xFFFF;
	}
	float vv = val;
	val *= 0x10000;
	r = (unsigned short)val;
	fp[0] = (unsigned char)(r >> 8);
	fp[1] = (unsigned char)(r & 0xFF);
	return r;
}

int main() {
	int i, j;
	float g;
	unsigned char v[2];
//	unsigned short c = htons(100);
	float gamma;
	int fout;
	unsigned short t;
	
	fout = open(GAMMA_FN, O_RDWR | O_CREAT, S_IROTH | S_IRGRP | S_IRUSR | S_IWUSR);
	if(fout < 0) {
		printf("failed to open \"%s\" file\n", GAMMA_FN);
		return -1;
	}
	for(j = 1; j <= 200; j++) {
		gamma = j;
		if(gamma > 100)
			gamma = 100;
		gamma /= 100.0;
		t = j;
		write(fout, &t, 2);
		for(i = 0; i < 257; i++) {
			g = i;
			g /= 256.0;
			g = powf(g, gamma);
			t = float_to_fp(v, g);
			write(fout, v, 2);
		}
	}
	close(fout);
	return 0;
}
