<?
/*!***************************************************************************
*! FILE NAME  : camogmgui.php
*! DESCRIPTION: command interface for the camogm recorder and camogm GUI
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: camogm_interface.php,v $
*!  Revision 1.5  2009/03/26 12:20:40  oneartplease
*!  audio and geotagging updates, both are not fully working yet though
*!
*!  Revision 1.9  2009/01/14 08:26:19  oneartplease
*!  minor updates
*!
*!
*!  Revision 1.0  2008/09/21 Sebastian Pichelhofer
*!  start and stop commands for ajax execution
*!
*/
$cmd = $_GET['cmd'];

if ($cmd == "run_camogm")
{
	exec('camogm2 /var/state/camogm_cmd > /dev/null 2>&1 &'); // "> /dev/null 2>&1 &" makes sure it is really really run as a background job that does not wait for input
	exec('echo "format=mov;" > /var/state/camogm_cmd'); //  Set quicktime *.mov as default format after startup.
}
else if ($cmd == "status")
{
	$pipe="/var/state/camogm.state";
	$cmd_pipe="/var/state/camogm_cmd";
	$mode=0777;
	if(!file_exists($pipe)) {
		umask(0);
		posix_mkfifo($pipe,$mode);
	}
	$fcmd=fopen($cmd_pipe,"w");
	fprintf($fcmd, "xstatus=%s\n",$pipe);
	fclose($fcmd);

	$status=file_get_contents($pipe);
	header("Content-Type: text/xml");
	header("Content-Length: ".strlen($status)."\n");
	header("Pragma: no-cache\n");
	printf($status);
}
else
{	

	header("Content-type: text/xml"); 
	header("Pragma: no-cache\n");
	
	function xml_header() {
		echo "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n";
		echo "<camogm_interface>\n";
	}
	function xml_footer() {
		echo "</camogm_interface>\n";
	}
	
	$cmd_pipe = "/var/state/camogm_cmd";
	$fcmd = fopen($cmd_pipe, "w");
	
	xml_header();
	echo "<command>".$cmd."</command>";
	echo "<".$cmd.">";
	
	switch ($cmd)
	{
		case "start":
			fprintf($fcmd,"start;\n");
			break;
		case "stop":
			fprintf($fcmd,"stop;\n");
			break;	
		case "file_rename":
			if ((!isset($_GET['file_old'])) || (!isset($_GET['file_new'])))
			{
				echo "failed";
				break;
			}
			$old_name = $_GET['file_old'];
			$new_name = $_GET['file_new'];
			$exists = false;
			if ($old_name == $new_name)
				echo "1";
			else 
			{
				if (strstr($new_name, "/var/hdd"))
				{
					if (file_exists($new_name))
					{
						$exists = true;
						echo "file exists";
					}
				}
				else
				{
					if (file_exists("/var/hdd/".$new_name))
					{
						$exists = true;
						echo "file exists";
					}
				}
			}
			if (!$exists)
				if (strstr($new_name, "/var/hdd"))
					echo rename("/var/hdd/".$old_name, $new_name);
				else
					echo rename("/var/hdd/".$old_name, "/var/hdd/".$new_name);
			break;
		case "mount":
			exec('mkdir /var/hdd');
			exec('mount /dev/hda1 /var/hdd');
			echo "done";
			break;
		case "mkdir":
			$dir_name = $_GET['name'];
			if (isset($dir_name) && (($dir_name != "") || ($dir_name != " ")))
			{
				exec('mkdir /var/hdd/'.$dir_name);
				echo "done";
				break;
			}
			else
				break;
		case "get_hdd_space":
			echo disk_free_space("/var/hdd");
			break;
		case "is_hdd_mounted":
			exec('mount', $arr);
			$mounted = implode("", $arr);
			if (strstr($mounted, "/dev/hda1"))
				echo substr($mounted, strpos($mounted, "/dev/hda1"),22);
			else
				echo "no HDD mounted";
			break;
		case "create_symlink":
			exec('ln -s /var/hdd /mnt/flash/html/hdd');
			break;
		case "list_files":
			if (!file_exists('/mnt/flash/html/hdd')) {
				echo "no webshare found";
			break;
			}
			$dir = $_GET["dir"];
			
			if (isset($dir) && ($dir != "") && ($dir != "/./") && ($dir != "/"))  // show "one level up" item if we are not in "home" directory
			{
				echo "<file>";
				echo "<type>updir</type>";
				echo "<name>..</name>";
				$file_remove_last_slash = substr($dir, 0, strlen($dir)-1);
				$file_pos_of_second_last_slash = strrpos($file_remove_last_slash, "/");
				$up_file = substr($dir, 0, $file_pos_of_second_last_slash+1);
				while(strpos($up_file, "//")) {
					$up_file = str_replace("//", "/", $up_file); 
				}
				if ($up_file == "")
					echo "<path>/</path>";
				else
					echo "<path>".$up_file."</path>";
				echo "<size>0</size>";
				echo "<date>0</date>";
				echo "</file>";
			}
			
			if ($handle = opendir('/mnt/flash/html/hdd'.$dir)) 
			{
				while ($file = readdir($handle))
				{
					if ($file != "." && $file != "..")
					{	
						echo "<file>";
						echo "<type>";
						if (is_dir("/var/hdd/".$dir.$file))
							echo "dir";
						else
							echo $extension = substr($file, strrpos($file, '.')+1, strlen($file)); 
						echo "</type>";
						echo "<name>".$file."</name>";
						echo "<path>".substr($dir, 1).$file."</path>";
						$size = filesize("/var/hdd/".$dir.$file);
						echo "<size>".$size."</size>";
						$date = date ("d M Y H:i:s", filectime("/var/hdd/".$dir.$file));
						echo "<date>".$date."</date>";
						echo "</file>";
					}
				}
				closedir($handle);
			}
			else
				echo "no webshare found<br>";
			break;
		case "set_prefix":
			$prefix = $_GET['prefix'];
			fprintf($fcmd, "prefix=%s;\n", $prefix);
			setcookie("directory", $prefix);
			break;
		case "init_compressor":
			elphel_compressor_run();
			break;
		case "check_audio_hardware":
			exec('arecord -l', $arr1);
			$audio_hardware = implode("", $arr1);
			if ($audio_hardware == "")
				echo "no Audio Hardware detected";
			else
			{	
				$message = substr($audio_hardware, strpos($audio_hardware, "],")+2);
				$message = substr($message, 1, strpos($message, "[")-2); 
				echo $message;
			}
			break;
		case "test_audio_playback":
			$soundfile = $_GET['soundfile'];
			exec('aplay '.$soundfile);
			break;
	}
	if ($fcmd)
		fclose($fcmd);
	echo "</".$cmd.">";
	xml_footer();
}
?>

