<?php
/*!***************************************************************************
*! FILE NAME  : init347.php
*! DESCRIPTION: Provides initialization of the 10347 board FPGA (called at init)
*! Copyright (C) 2007 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: init347.php,v $
*!  Revision 1.1.1.1  2008/11/27 20:04:03  elphel
*!
*!
*!  Revision 1.1  2007/12/06 19:02:50  elphel
*!  collected most of the camera PHP script into one  /packages/web/353/php_top directory
*!
*!  Revision 1.2  2007/10/12 23:00:45  elphel
*!  adding power347.php to control power supplies and power timeout (supporting new FPGA interface)
*!
*!  Revision 1.1.1.1  2007/10/10 06:09:44  elphel
*!  This is a fresh tree based on elphel353-2.10
*!
*/


//slow version of functions - they will reopen i2c for each word
function send347($register_address,$d0=0,$d1=-1,$d2=-1,$d3=-1,$d4=-1,$d5=-1,$d6=-1,$d7=-1) {
   $i2c  = fopen('/dev/xi2c16', 'w');
   fseek ($i2c, 0x2000+2*$register_address) ; //Micron sensor slave 0xba
   fwrite($i2c, chr (floor($d0/256)).chr ($d0-256*floor($d0/256)));
   if ($d1>=0) {
    fwrite($i2c, chr (floor($d1/256)).chr ($d1-256*floor($d1/256)));
    if ($d2>=0) {
     fwrite($i2c, chr (floor($d2/256)).chr ($d2-256*floor($d2/256)));
     if ($d3>=0) {
      fwrite($i2c, chr (floor($d3/256)).chr ($d3-256*floor($d3/256)));
      if ($d4>=0) {
       fwrite($i2c, chr (floor($d4/256)).chr ($d4-256*floor($d4/256)));
       if ($d5>=0) {
        fwrite($i2c, chr (floor($d5/256)).chr ($d5-256*floor($d5/256)));
        if ($d6>=0) {
         fwrite($i2c, chr (floor($d6/256)).chr ($d6-256*floor($d6/256)));
         if ($d7>=0) {
          fwrite($i2c, chr (floor($d7/256)).chr ($d7-256*floor($d7/256)));
         }
        }
       }
      }
     }
    }
   }
   fclose($i2c);
}

function receive347($register_address) { // very slow?
   $i2c  = fopen('/dev/xi2c16', 'r');
   fseek ($i2c, 0x2000+2*$register_address) ; //Micron sensor slave 0xba
   $data = fread($i2c, 2);
   fclose($i2c);
   $v=unpack('n1',$data);
   print_r($v);
//   printf("date is %d(0x%x)\n",$v,$v);
//   echo ord($data[0])+ord($data[1]);
//   echo "<br/>\n";
//   return ord($data[0])+ord($data[1]);
   return $v[1];
}

function i2cread16 ($start,$length=256) {
   $i2c  = fopen('/dev/xi2c16', 'r');
   fseek ($i2c, 2*$start) ; // 16-bit registers
   $data = fread($i2c, 2*$length);
   fclose($i2c);
   $regs=unpack('n*',$data);
//   print_r($regs);
   echo "<table>\n";
   for ($i=0; $i<$length; $i+=16){
     printf("<tr><td>%x</td>",$i);
     for ($j=1; $j<17; $j++){
       printf("<td>%x</td>",$regs[$i+$j]);
     }
     echo "</tr>\n";
   }
   echo "</table>\n";
}



send347 (0xa0,0x1234, 0x5678, 0x9, 0xabcd); // time - just testing  registers

send347 (0x10,0x0);// turn analog power off

send347 (0x08,0x32);     // set JPEG quality (this location has no effect in FPGA - used just as a memory)
send347 (0x0a,0x0);      // turn off monochrome mode
send347 (0x0c,0x64);     // set gamma = 1.0 (100 decimal, 0x64)
send347 (0x04,1,1);      // set "parameters changed", so the first image request will set parameters to those from CCD
send347 (0x2c,0x0);      // turn DAC LD off (changes will take effects later when it will be reenabled)
send347 (0x28,0x4, 0xf); //write DAC control registers
// now set analog voltages (may need individual ajustments)
send347 (0x20,0x780); // Vsub +11.3V
send347 (0x21,0x680); // Vog -2.5V
send347 (0x22,0xec0); // Vrd 11 V
send347 (0x23,0xb80); // Vdd +15V
send347 (0x24,0x180); // Vh1lh +1.0V
send347 (0x25,0x180); // Vh1h +1.0V
send347 (0x26,0xa00); // Vh2l -4.0V
send347 (0x27,0x8c0); // Vrgl -3.5V
send347 (0x2d,0x0);   // Enable updating of analog outputs (CLD on)
// Other DACs that control horizontal phases amplitudes (7 bits)
send347 (0x30,0x50); // RG  (5V)
send347 (0x31,0x42); // H1  (5V)
send347 (0x32,0x78); // H1L (8V)
send347 (0x33,0x3c); // H2  (5V)

// data to dac2900 to set the vertical phases levels (dynamic), 10 bits
//prototype board - bit 8 floating, connecting to bit0
//send347 (0x40,0x226, 0x340); // 0: V1M=0V, V2L=-9V
//send347 (0x42,0x340, 0x226); // 1: V1L=-9V, V2M=0V
//send347 (0x44,0x226, 0x226); // 2: V1M=0V, V2M=0V
//send347 (0x46,0x340, 0x0c0); // 3: V1L=-9V, V2H=8V
//send347 (0x48,0x340, 0x340); // 4: V1L=-9V, V2L=-9V
//send347 (0x4a,0x226, 0x3ff); // # 5: V1M=0V, V2A=-14V
//send347 (0x4c,0x3ff, 0x226); // 6: V1A=-14V, V2M=0V
//send347 (0x4e,0x226, 0x340); // 7: V1M=0V, V2L=-9V
send347 (0x40,0x226, 0x341); // 0: V1M=0V, V2L=-9V
send347 (0x42,0x341, 0x226); // 1: V1L=-9V, V2M=0V
send347 (0x44,0x226, 0x226); // 2: V1M=0V, V2M=0V
send347 (0x46,0x341, 0x0c0); // 3: V1L=-9V, V2H=8V
send347 (0x48,0x341, 0x341); // 4: V1L=-9V, V2L=-9V
send347 (0x4a,0x226, 0x3ff); // # 5: V1M=0V, V2A=-14V
send347 (0x4c,0x3ff, 0x226); // 6: V1A=-14V, V2M=0V
send347 (0x4e,0x226, 0x341); // 7: V1M=0V, V2L=-9V
// end of analog settings
# substracts (14 bits to be subtracted from the ADC outputs (one for each color, for each of 2 outputs)
send347 (0x50, 0, 0, 0, 0); // Output 1: B G G R
send347 (0x54, 0, 0, 0, 0); // Output 2: G B R G
// Individual gains for the channels (same sequence as subtracts), 16 bits, 1000 being unity gain (all 14 bits of ADC are used)
// It is not the case, as the ADC range is wider then the CCD can provide,so the values should be definitely bigger than 1000
//send347 (0x58, 0x1b58, 0x1964, 0x1964, 0x2af8); // Output 1: B G G R
//send347 (0x5c, 0x1964, 0x1b58, 0x2af8, 0x1964); // Output 2: G B R G

send347 (0x58, 0x1964, 0x1b58, 0x2af8, 0x1964); // Output 2: G B R G
send347 (0x5c, 0x1b58, 0x1964, 0x1964, 0x2af8); // Output 1: B G G R




send347 (0x6c, 0, 0);       // (0x600,0x600) compensate bandwidth (needed for 25MHz only) Adds a fraction of the previous pixel to the current one
#Output windows positions (master, slave) in the following sequence: ((top-1)/(height+1)/(left-1)/(width-1))
//send347 (0x60, 0xf,  0xa73, 0x14, 0x7e1); // 18x18 tiles)
  send347 (0x60, 0xf,  0xa75, 0x12, 0xfe1); // full 20x20 ?
//  send347 (0x60, 0xf,  0xa75, 0x13, 0xfe1); // full 20x20 ?
//send347 (0x60, 0xf,  0xa75, 0x14, 0xfe1); // full 20x20 ?

//send347 (0x60, 0x10, 0xa71, 0x1f, 0xfdf); // full frame to master (18x18 tiles)
send347 (0x64, 0x0f, 0xa73, 0x7f4, 0x7e1); # 18x18 tiles
send347 (0x68, 0x7f6); // half of the full line (even, lsb - shift)

# Timing of horizontal phase signals and CDS/ADC
//new - phase shift, ~50% duty cycle
//send347 (0x6e, 0x3c1e, 0x0); // clk_itf (~clk2x) phase 0
send347 (0x6e, 0x783c, 0x0); // clk_itf (~clk2x) phase 40
//send347 (0x6e, 0xf078, 0x0); // clk_itf (~clk2x) phase 80
//send347 (0x6e, 0xe0f0, 0x1); // clk_itf (~clk2x) phase 120
//send347 (0x6e, 0xc1e0, 0x3); // clk_itf (~clk2x) phase 160
//send347 (0x6e, 0x83c1, 0x3); // clk_itf (~clk2x) phase 200
//send347 (0x6e, 0x0783, 0x3); // clk_itf (~clk2x) phase 240
//send347 (0x6e, 0x0f07, 0x2); // clk_itf (~clk2x) phase 280
//send347 (0x6e, 0x1e0f, 0x0); // clk_itf (~clk2x) phase 320
# timing - period = 9cycles (72ns)
send347 (0x70, 0x8); // pixel period (write one less than needed) = 9 clk (72ns). May run faster - (at 40ns), but output amplifiers can have some problems (see compensation above)

send347 (0x71, 0x5);  // write PH inactive (for period ==5 should be 3, period 9 - 5)
# The next 8 signals are active at the overlapping 8ns intervals, controlled by the 32 bits (starting with LSB of lower 16-bit word):
# bit 0, lower word:  active ( 0- 7), bit 1 - ( 4-11), 2 - ( 8-15) ... 15 - ( 56.. 63) ns
# bit 0, higher word: active (64-71), bit 1 - (68-75), 2 - (72-79) ... 15 - (120..127) ns

send347 (0x72, 0x3540, 0x0); // ADCCLK 
send347 (0x74, 0x500, 0x0);  // SHPA 
send347 (0x76, 0x1, 0x1);    // SHDA
send347 (0x78, 0x500, 0x0);  // SHPB
send347 (0x7a, 0x1, 0x1);    // SHDB
send347 (0x7c, 0x3540, 0x0); // clk_adc
send347 (0x7e, 0x2010, 0x0); // clk2x
//send347 (0x80, 0x800, 0x63, 0x9); //(0x4e1c, 0x63, 0x9) ffff ffff ffffkeep-alive and on/off delays 20.0sec, 0.1 sec, 0.01 sec
//send347 (0x80, 0x1000, 0x63, 0x9); //(0x4e1c, 0x63, 0x9) ffff ffff ffffkeep-alive and on/off delays 20.0sec, 0.1 sec, 0.01 sec
send347 (0x80, 0x4e1c, 0x63, 0x9); //(0x4e1c, 0x63, 0x9) ffff ffff ffffkeep-alive and on/off delays 20.0sec, 0.1 sec, 0.01 sec

send347 (0x84, 25000,24999,250, 20000); //PWM control - period=25000, starting from 24999, decrementing by 250
                                        // until 20000
//send347 (0x16, 0x1);         // make fan run only when the analog power is on (2 - always, 0 - never)
send347 (0x16, 0x8);         // Alternating sequences (0x0 - "old" sequence, no alternating). Fan should be disabled - it is used for triggering other cameras

// - sequencer
# Sequencer program  (add miniassembler later?)
$LOOP=      0x0000;
$ELOOP=     0x1000;
$JUMPOUT=   0x1400;
$JUMP=      0x1800;
$CJUMP=     0x1c00;
$RESET=     0x2000;
$TGLEXPOS=  0x3000;
$TGLFRAME=  0x4000;
$TGLLINE=   0x5000;
$TGLFD=     0x6000;
$TGLSHUTTER=0x7000;
$VPH0=      0x8000;
$VPH1=      0x9000;
$VPH2=      0xa000;
$VPH3=      0xb000;
$VPH4=      0xc000;
$VPH5=      0xd000;
$VPH6=      0xe000;
$VPH7=      0xf000;

$NLINES=0xaa0; // 2720;
$NPIX=  0x7f8; // 2040;	// total pixels in a half-line (with black ones)

//$T_HD=  0x064; // 100;   //  4.0 us (3.0/3.5/10.0), HCCD delay
//$T_VCCD=0x064; // 100;   //  4.0 us (3.0/3.5/20.0), VCCD transfer time
//$T_V3RD=0x0fa; // 250;   // 10.0 us (8.0/10.0/15.0), Photodiode transfer time
//$T_V3P= 0x5dc; // 1500;   // 60.0 us (50.0/60.0/80.0), Photodiode transfer time
//$T_V3D= 0x1f4; // 500;   // 20.0 us (15.0/20.0/80.0), VCCD delay
//$T_S=   0x07d; // 125;   //  5.0 us (3.0/4.0/10.0), Shutter pulse time
//$T_SD=  0x032; //  50;   //  2.0 us (1.0/1.5/10.0), Shutter delay time
//$T_FD=  0x019; // 25;   //  1.0 us (0.5/?/?) Fast Dump Gate delay
//$T_SFD= 0x9c4; // 2500;   //100.0 us (slow "fast dump") to reduce power
//$T_MS=  0x07d; // 125;   //  5.0 us - rather arbitrary - mechanical shutter trigger duration

//for clock= 125MHz/9:
$T_HD=   55;    //  4.0 us (3.0/3.5/10.0), HCCD delay
$T_VCCD= 55;    //  4.0 us (3.0/3.5/20.0), VCCD transfer time
$T_V3RD= 139;   // 10.0 us (8.0/10.0/15.0), Photodiode transfer time
$T_V3P=  833;   // 60.0 us (50.0/60.0/80.0), Photodiode transfer time
$T_V3D=  278;   // 20.0 us (15.0/20.0/80.0), VCCD delay
$T_S=     70;   //  5.0 us (3.0/4.0/10.0), Shutter pulse time
$T_SD=    28;   //  2.0 us (1.0/1.5/10.0), Shutter delay time
$T_FD=    14;   //  1.0 us (0.5/?/?) Fast Dump Gate delay
$T_SFD= 1389;   //100.0 us (slow "fast dump") to reduce power
$T_MS=    70;   //  5.0 us - rather arbitrary - mechanical shutter trigger duration




# first erase after power on (~10000 lines?)
send347 (0x100,$RESET             ); // reset toggle values
send347 (0x101,$RESET             ); // just nop
send347 (0x102,$VPH0+$T_FD         );  // V1M, V2L
send347 (0x103,$TGLFD+$T_FD        ); // turn fast dump on
send347 (0x104,$LOOP+0x18          );  // outer loop - 0x10 times. With first CCD 0x0a seems to be a thereshold value
 send347 (0x105,$LOOP+0x3e8       );  // inner loop - 1000 times
  send347 (0x106,$VPH1+$T_VCCD     );  // V1L, V2M

  send347 (0x107,$VPH0+$T_HD       );  // V1M, V2L (*8064)
# Seems that 5400 is optimal (lower values - horizontal will take more time to flash)
# Increase that value to 5800 to lower power consumption if the camera resets itself when turning on analog power
# Other place to reduce power stress - increase power-on delay (address 0x81)
//  send347 (0x108,$TGLLINE+0x100   );  // PH1, PH2 on //ajust to flashing, adjust time to power not too high
// 0x100 - too low, 0x400 - enough, maybe inbetween is fine too
  send347 (0x108,$TGLLINE+0x400   );  // PH1, PH2 on //ajust to flashing, adjust time to power not too high
  send347 (0x109,$TGLLINE+$T_HD    );  // PH1, PH2 off.


 send347 (0x10a,$ELOOP            );
send347 (0x10b,$ELOOP             );
send347 (0x10c,$TGLFD+$T_HD       ); // turn fast dump off
           # Here starts the main loop:
send347 (0x10d,$LOOP              );  // loop forever
 send347 (0x10e,$RESET            );  // reset toggle values
 send347 (0x10f,$VPH0+$T_FD       );  // V1M, V2L
 send347 (0x110,$TGLFD+$T_FD      );  // turn fast dump on
 send347 (0x111,$LOOP             );  // forever until start
  send347 (0x112,$VPH1+$T_VCCD    );  // V1L, V2M
  send347 (0x113,$CJUMP+0x19      );  //LABEL1
  send347 (0x114,$VPH0+$T_SFD     );  // V1M, V2L, slow
           # here - add faster reaction to the interrupt
  send347 (0x115,$TGLLINE+10      );  // PH1, PH2 on //flash just a little of horizontal register with each line
  send347 (0x116,$TGLLINE+$T_HD   );  // PH1, PH2 off.

  send347 (0x117,$CJUMP+0x1a      );  //LABEL2
 send347 (0x118,$ELOOP            );
 send347 (0x119,$VPH0+$T_FD       );  // V1M, V2L, LABEL1
           # inserting mechanical shutter
 send347 (0x11a,$TGLSHUTTER+$T_MS );  // turn mechanical shutter pulse on (5usec)
 send347 (0x11b,$TGLSHUTTER       );      // turn mechanical shutter pulse off
 send347 (0x11c,$LOOP+51          );  // shutter delay *** external address **** (2715 cycles, 108.6usec) (1 cycle = 0.1955msec)
  send347 (0x11d,$VPH1+$T_VCCD    );  // V1L, V2M  - 100 cycles (4usec)
  send347 (0x11e,$VPH0+$T_SFD     );  // V1M, V2L, slow - 2500 (100usec)
  send347 (0x11f,$TGLLINE+10      );  // PH1, PH2 on  10 cyc - 0.4 usec//flash just a little of horizontal register with each line
  send347 (0x120,$TGLLINE+$T_HD   );  // PH1, PH2 off. 100 cyc - 4 sec
 send347 (0x121,$ELOOP            );  // end of shutter delay
           # continue with old code.
 send347 (0x122,$TGLFD+$T_HD      );  // turn fast dump off (label2)
 send347 (0x123,$TGLSHUTTER+$T_S  );  // turn shutter on
 send347 (0x124,$TGLEXPOS         );  // turn exposure on
 send347 (0x125,$TGLSHUTTER+$T_SD );  // turn shutter off

// send347 (0x126,$LOOP+1          );  //exposure, outer loop ***************
//  send347 (0x127,$LOOP+5          );  //new - inner loop
//   send347 (0x128,$VPH0+0x400     );  //exposure - step duration 2499=100usec for 25 MHz, update (*9/5)
//  send347 (0x129,$ELOOP           ); 
// send347 (0x12a,$ELOOP            );



 send347 (0x126,$LOOP+100         );  //exposure, outer loop ***************
  send347 (0x127,$LOOP+10         );  // inner loop - with 10 us step it can be up to 40.95 usec. Change it if you need longer exposures
   send347 (0x128,$VPH0+0x8a      );  //exposure - step duration 139=10.008us for 125MHz/9
  send347 (0x129,$ELOOP           ); 
 send347 (0x12a,$ELOOP            );

 send347 (0x12b,$VPH2+$T_V3P      );  // V1M, V2M
 send347 (0x12c,$VPH3+$T_V3RD     );  // V1L, V2H
 send347 (0x12d,$TGLEXPOS         );  // turn exposure off
 send347 (0x12e,$VPH2+$T_V3D      );  // V1M, V2M
 send347 (0x12f,$VPH0+$T_VCCD     );  // V1M, V2L, different delay
 send347 (0x130,$TGLFRAME         );  // turn frame on
 send347 (0x131,$LOOP+$NLINES     );  // shift out frame - try extra lines **
  send347 (0x132,$VPH1+$T_VCCD    );  // V1L, V2M (*9064)
  send347 (0x133,$VPH0+$T_HD      );  // V1M, V2L (*8064)
  send347 (0x134,$TGLLINE+$NPIX   );  // PH1, PH2 on
  send347 (0x135,$TGLLINE+$T_HD   );  // PH1, PH2 off. Not sure in timing (*5064?)
 send347 (0x136,$ELOOP            );
 send347 (0x137,$TGLFRAME         );  // turn frame off
send347 (0x138,$ELOOP             );   // end outer (forever) loop - restart acquisition
// adding labels list

send347 (0x1ff,0x126              );   // address of exposure setting
send347 (0x1fe,0x11c              );   // address of mechanical shutter delay


# End of sequencer program

//! possible FPGA bug - if power is enabled - starts acquisition (and power overload) at boot time
//! disable here, need explicit enable before getting images
//send347 (0x11, 0x0);               //  pre-enable power (will go on after the request)
//send347 (0x11, 0x0);               //  pre-enable power (will go on after the request)
//! let's try enable everything - see if it will reset
send347 (0x10, 0xf);   //  pre-enable power (will go on after the request), enable shutter

send347 (0xa0,0x1234);
send347 (0xa1,0x5678);
send347 (0xa2,0x9);
send347 (0xa3,0xabcd);
send347 (0xa5);
/*
program shutter default sequence (if not programmed yet)
001200: 43d0 9020 5315 9001 43d0 9800    0
001280: 43d0 9200 5315 9001 43d0 9080    0
*/

   $i2c  = fopen('/dev/xi2c16', 'r');
   fseek ($i2c, 2*0x1200) ; // 16-bit registers
   $data = fread($i2c, 2);
   fclose($i2c);
   $regs=unpack('n*',$data);
//echo "<pre>";
//print_r ($regs);
//echo "</pre>";
   if ($regs[1]==0) {
    printf("<p>Mechanical shutter sequence blank - initializing to default one.</p>\n");
    send347 (0x200,0x43d0,0x9020,0x5315,0x9001,0x43d0,0x9800,0x0);
    send347 (0x280,0x43d0,0x9200,0x5315,0x9001,0x43d0,0x9080,0x0);
   } else {
    printf("<p>Mechanical shutter sequence already initialized.</p>\n");
   }

//i2cread16(0x1000);
i2cread16(0x1000,0x300);
// for ($i=0;$i<16;$i++) printf("%x",receive347(0xb0+$i));printf("<br/>\n");
//send347 (0xa5); for ($i=0;$i<16;$i++) printf("%x",receive347($i));printf("<br/>\n");
//send347 (0xa5); for ($i=0;$i<16;$i++) printf("%x",receive347($i));printf("<br/>\n");
//send347 (0xa5); for ($i=0;$i<16;$i++) printf("%x",receive347($i));printf("<br/>\n");
//send347 (0xa5); for ($i=0;$i<16;$i++) printf("%x",receive347($i));printf("<br/>\n");
//send347 (0xa5); for ($i=0;$i<16;$i++) printf("%x",receive347($i));printf("<br/>\n");
?>
