<?php
/*!*******************************************************************************
*! FILE NAME  : senspars.php
*! DESCRIPTION: Provides control of FPGA compressor/image acquisition
*!              to the circular buffer (circbuf)
*! Copyright (C) 2007 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: senspars.php,v $
*!  Revision 1.1.1.1  2008/11/27 20:04:03  elphel
*!
*!
*!  Revision 1.1  2007/12/06 19:02:52  elphel
*!  collected most of the camera PHP script into one  /packages/web/353/php_top directory
*!
*!  Revision 1.1  2007/10/16 19:25:27  elphel
*!  Added php script to control driver parameters (P_XXX, as defined in c313a.h) instead of the IOCTL. It is possible to control sensor phase with it
*!
*!
*/

 $cmd=$_GET['cmd'];
 $addr=$_GET['addr'];
 $data=$_GET['data'];

// if (is_numeric ($addr)) $addr=$addr+0;
// if (is_numeric ($data)) $data=$data+0;

 switch  ($cmd) {
   case "list":
   $start=0;
   $length=2048;
   $sensorpars  = fopen('/dev/sensorpars', 'r');
   fseek ($sensorpars, 4*$start) ; // 32-bit registers
   $d = fread($sensorpars, 4*$length);
   fclose($sensorpars);
   $regs=unpack('V*',$d); // unsigned long, little endian
//   print_r($regs);
   echo "<table>\n";
   for ($i=0; $i<$length; $i+=16){
     printf("<tr><td>%x</td>",$i);
     for ($j=1; $j<17; $j++){
       printf("<td>%x</td>",$regs[$i+$j]);
     }
     echo "</tr>\n";
   }
   echo "</table>\n";
//}

   break;
   case "read":
     if (is_numeric ($addr)) {
       $sensorpars  = fopen('/dev/sensorpars', 'r');
//echo "addr=".$addr;
       fseek ($sensorpars, 4*($addr+0)) ; // 32-bit registers
       $d = fread($sensorpars, 4);
       fclose($sensorpars);
       $regs=unpack('V*',$d); // unsigned long, little endian
//   print_r($regs);
       printf ("<p>%d(0x%x):%d(0x%x)</p>\n",($addr+0),($addr+0),$regs[1],$regs[1]);
     }

  break;
   case "write":
    if (is_numeric ($addr) && is_numeric ($data)) {
       $sensorpars  = fopen('/dev/sensorpars', 'w');
       fseek ($sensorpars, 4*($addr+0)) ; // 32-bit registers
       $d=$data+0;
       fwrite($sensorpars, chr($d & 0xff).chr(($d>>8) & 0xff).chr(($d>>16) & 0xff).chr(($d>>24) & 0xff));
       fclose($sensorpars);
    }
   break;
   default:
    echo <<<USAGE
   <p>This read/writes P_XXX registers as defined in  <a href="http://elphel.cvs.sourceforge.net/elphel/elphel353-7.1/os/linux-2.6-tag--devboard-R2_10-4/include/asm-cris/elphel/c313a.h">os/linux-2.6/include/asm-cris/elphel/c313a.h</a>.</p>
   <ul>
    <li><b>cmd=list</b> - show all registers</li>
    <li><b>cmd=read&addr=<i>ra</i></b> -  read register <i>ra</i></li>
    <li><b>cmd=write&addr=<i>ra</i>&data=<i>rd</i></b> -  write <i>rd</i> to register <i>ra</i></li>
  </ul>
USAGE;

 }
?>
