/*!***************************************************************************
*! FILE NAME  : preset.js
*! DESCRIPTION: javascript for the Preset Browser
*! Copyright (C) 2009 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: preset.js,v $
*!  Revision 1.2  2009/03/17 22:04:56  oneartplease
*!  presets can now be viewed and edited
*!
*!  loading presets works with sensor window settings only at the moment
*!
*!  some 8.0 adaptions
*!
*!  Revision 1.1  2009/01/14 08:17:12  oneartplease
*!  version 0.1 of the preset manager
*!
*!
*!  Revision 1.0  2009/01/03 Sebastian Pichelhofer
*!  
*!
*/
var parameter_names = ['woi_left', 
					   'woi_top',
					   'woi_width',
					   'woi_height',
					   'binning_hor',
					   'binning_ver',
					   'dec_hor',
					   'dec_ver',
					   'mirror',
					   'color',
					   'jpeg_qual',
					   'gain_gb',
					   'gain_b',
					   'gain_g',
					   'gain_r',
					   'scale_r',
					   'scale_g',
					   'scale_b',
					   'gamma',
					   'white_level',
					   'black_level',
					   'sat_r',
					   'sat_b',
					   'exposure',
					   'fps'				   
					   ];

function init() {
	setTimeout('is_hdd_mounted()', 250);
	setTimeout('update_parameters()', 500);	
}
function mount_hdd() {
	makeRequest('preset_interface.php', '?cmd=mount');
	document.getElementById('mount_hdd_button').style.display = "none";
	
}
function process_mount_hdd(xmldoc) {
	var response = xmldoc.getElementsByTagName('mount')[0].firstChild.data;
	if (response == "done")
		setTimeout('is_hdd_mounted()', 300);
}
function is_hdd_mounted() {
	makeRequest('preset_interface.php', '?cmd=is_hdd_mounted');	
}
function process_hdd_mount(xmldoc) {			
	var response = xmldoc.getElementsByTagName('is_hdd_mounted')[0].firstChild.data;
	if (response == "no HDD mounted")
	{
		document.getElementById('mounted_devices').innerHTML = "no devices found";
		document.getElementById('refresh_file_list').style.display = "none"; // hide "reload" button
		document.getElementById('create_webshare_button').style.display = "none"; // hide "create webshare" button
		document.getElementById('create_folder').style.display = "none"; // hide "create folder" button
		document.getElementById('set_rec_dir').style.display = "none"; // hide "set record directory" button
		
		// Ignore all odds and just mount it
		setTimeout('mount_hdd()', 300);
	}
	else // we have a hdd mounted
	{
		document.getElementById('mount_hdd_button').style.display = 'none'; // hide mount button
		document.getElementById('refresh_file_list').style.display = "inline"; // show "reload" button
		document.getElementById('create_webshare_button').style.display = "inline"; // show "create webshare" button
			document.getElementById('create_folder').style.display = "inline"; // show "create folder" button
		document.getElementById('set_rec_dir').style.display = "inline"; // show "set record directory" button
		document.getElementById('mounted_devices').innerHTML = response;
		setTimeout('get_hdd_space()', 300);
		setTimeout('list_files("")', 600);
	}
}
function create_folder() {
	var name_prompt = prompt("Folder Name:");
	if (name_prompt != null)
		makeRequest('preset_interface.php', '?cmd=mkdir&name=' + getCookie('preset_current_dir') + "/" + name_prompt);
}
function process_mkdir(xmldoc) {
	var sucess = xmldoc.getElementsByTagName('mkdir')[0].firstChild.data;
	if (sucess == "done")
	{
		setTimeout("list_files(getCookie('preset_current_dir'))", 500);
	}
	else
		alert("error creating folder");
}
function get_hdd_space() {
	makeRequest('preset_interface.php', '?cmd=get_hdd_space');
}
function process_hdd_space(xmldoc) {
	var response = xmldoc.getElementsByTagName('get_hdd_space')[0].firstChild.data;
	document.getElementById('hdd_rem').innerHTML = Math.round(response/1024/1024/1024*100)/100 + " GB";
}
function create_webshare() {
	makeRequest('preset_interface.php', '?cmd=create_symlink');
	document.getElementById('create_webshare_button').style.display = "none";
	setTimeout('list_files("")', 500);
}
function set_rec_dir() {
	// Show Format Tab
	setCookie('preset_tab', 1, 365);
	TabbedPanels1.showPanel(1);
	
	document.getElementById('directory').value = "/var/hdd/presets" + getCookie('preset_current_dir');	
	makeRequest('preset_interface.php', '?cmd=set_prefix&prefix=' + "/var/hdd/presets" + getCookie('preset_current_dir'));
}
function list_files(dir) {
	if (dir == "")
	{
		makeRequest('preset_interface.php', '?cmd=list_files');
		setCookie("preset_current_dir", "/", 365);
	}
	else
	{
		makeRequest('preset_interface.php', '?cmd=list_files&dir=' + dir);
		setCookie("preset_current_dir", dir, 365);
	}	
	document.getElementById('files_current_folder').innerHTML = "/var/hdd/presets" + getCookie("preset_current_dir");
}
function process_list_file(xmldoc) {
	var can_continue = true;
	if (xmldoc.getElementsByTagName('list_files').length > 0) {
		if (xmldoc.getElementsByTagName('list_files')[0].firstChild.data != null) {
			if (xmldoc.getElementsByTagName('list_files')[0].firstChild.data == "no webshare found") {
				can_continue = false;
				document.getElementById('create_webshare_button').style.display = "inline";
				document.getElementById('filelist').innerHTML = "no webshare found<br>";
				
				// ingore all odds and just create the webshare
				setTimeout('create_webshare()', 300);
			}
		}
	}
	if (can_continue)
	{
		var count = xmldoc.getElementsByTagName('file').length;
		var response = "<table cellspacing=\"0px\" cellpadding=\"3px\" width=\"100%\">";
		response  += "<tr><td width=\"40%\"><b>File</b></td><td width=\"30%\"><b>Creation Date</b></td><td><b>Size</b></td><td></td></tr>";
		
		for ( var i = 0; i < count; i++ ) {
			document.getElementById('create_webshare_button').style.display = "none";
			var skip = false;
			if (xmldoc.getElementsByTagName('file')[i].childNodes[1].firstChild.data == "lost+found")
				skip = true;
				
			if (!skip) {
				if (i%2 == 0)
					response += '<tr class="file_row_even">';
				else
					response += '<tr class="file_row_odd">';
				response += "<td>";
				type = xmldoc.getElementsByTagName('file')[i].childNodes[0].firstChild.data;
				filename = xmldoc.getElementsByTagName('file')[i].childNodes[1].firstChild.data;
				path = xmldoc.getElementsByTagName('file')[i].childNodes[2].firstChild.data;
				if(xmldoc.getElementsByTagName('file')[i].childNodes[3].firstChild.data != " ")
					desc = xmldoc.getElementsByTagName('file')[i].childNodes[3].firstChild.data;				
				switch (type) {
					case 'updir':
					response += '<a href="#" onClick="list_files(\'' + path + '\');">';
					response += '<img src="images/up_folder.gif"> ';
					response += filename + "</a>";
					break;

					case 'dir':
					response += '<a href="#" onClick="list_files(\'/' + path + '/\');">';
					response += '<img src="images/folder.gif"> ';
					response += filename + "</a>";
					break;
					
					default:
					response += "<a href=\"http://" + location.host + "/hdd/presets/" + path + "\">";
					response += filename + "</a>";
					if(xmldoc.getElementsByTagName('file')[i].childNodes[3].firstChild.data != " ")
						response += "<br /><span class=\"preset_desc\">" + desc + "</span>";
					break;
				}
				response += "</td>";
				response += "<td>";
				var date = xmldoc.getElementsByTagName('file')[i].childNodes[5].firstChild.data;
				response += date;
				response += "</td>";
				response += "<td>";
				var size = xmldoc.getElementsByTagName('file')[i].childNodes[4].firstChild.data;
				response += Math.round(size*100/1024)/100 + " KB";
				response += "</td>";
				if (type != 'dir' && type != 'updir') { 
					response += "<td><a href=\"#\" onClick=\"load_preset('" + filename + "');\">load</a></td>";
					response += "<td><a href=\"http://" + location.host + "/admin-bin/editcgi.cgi?file=/var/hdd/presets/" + path + "\" target=\"_blank\"> view/edit</a></td>";
				}
				else
					response += "<td></td><td></td>";
				response += "</tr>";
			}	
		}
		response += "</table><br>";
		document.getElementById('filelist').innerHTML = response;
	}
}
function makeRequest(url, parameters) {
	http_request = false;
	if (window.XMLHttpRequest) { // Mozilla, Safari,...
		http_request = new XMLHttpRequest();
		if (http_request.overrideMimeType) {
			http_request.overrideMimeType('text/xml');
		}
	} else if (window.ActiveXObject) { // IE
		try {
			http_request = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
				http_request = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (e) {}
	}
}
	if (!http_request) {
 alert('Cannot create XMLHTTP instance');
 return false;
}
	http_request.onreadystatechange = process_request;
	http_request.open('GET', url + parameters, true);
	http_request.send(null);
}
function process_request() {
	if (http_request.readyState == 4) {
		if (http_request.status == 200) {
			var xmldoc = http_request.responseXML;
			if (xmldoc.getElementsByTagName('command').length > 0) {
				var command = xmldoc.getElementsByTagName('command')[0].firstChild.data;
				switch (command)
				{
					case "is_hdd_mounted":
						process_hdd_mount(xmldoc);
						break;
					case "list_files":
						process_list_file(xmldoc);
						break;
					case "file_rename":
						process_rename_file(xmldoc);
						break;
					case "get_hdd_space":
						process_hdd_space(xmldoc);
						break;	
					case "mount":
						process_mount_hdd(xmldoc);
						break;	
					case "mkdir":
						process_mkdir(xmldoc);
						break;
					case "update_parameters":
						process_update_parameters(xmldoc);
						break;							
					default:
						break;
				}
			}
		}
	}
}
function rename_file(oldname, newname) {
	makeRequest('camogm_interface.php', '?cmd=file_rename&file_old=' + oldname + '&file_new=' + newname);
}
function process_rename_file(xmldoc) {
	var response = xmldoc.getElementsByTagName('file_rename')[0].firstChild.data;
	
	if (response != "1")
		alert ("renaming failed: " + response);
	
	setTimeout('list_files(getCookie("preset_current_dir"))', 300);	
}
function update_live_image() {
	document.getElementById('live-picture').src = "http://" + location.host + ":8081/bimg?" + Math.random()*99999999999;
}
function size_up_image() {
	document.getElementById('live-picture').width += 40;
	document.getElementById('live-picture').height += 30;

	var old_height = document.getElementById('CollapsiblePanel1Inhalt').style.height;
	document.getElementById('CollapsiblePanel1Inhalt').style.height = parseInt(old_height.substring(0, old_height.length-2)) + 30; + "px";
}
function size_down_image() {
	document.getElementById('live-picture').width -= 40;
	document.getElementById('live-picture').height -= 30;
	
	var old_height = document.getElementById('CollapsiblePanel1Inhalt').style.height;
	document.getElementById('CollapsiblePanel1Inhalt').style.height = parseInt(old_height.substring(0, old_height.length-2)) - 30; + "px";
}
function help(caller) {
	switch (caller) {
		case 'sensor':
			alert("The sensor is not yet in a working state. It needs to be initated first. Tools like camvc should automatically do this for you.");
			break;
		
	}
}
function live_image_auto_update_changed() {
	if (document.getElementById('live_image_auto_update').value == "yes") {
		validate_update_freq();
		update_live_image_loop();
	}
}
function validate_update_freq() {
	if (document.getElementById('live_image_auto_update_frequency').value > 60)
		document.getElementById('live_image_auto_update_frequency').value = 60;
	if (document.getElementById('live_image_auto_update_frequency').value < 1)
		document.getElementById('live_image_auto_update_frequency').value = 1;
}
function update_live_image_loop() {
	if (document.getElementById('live_image_auto_update').value == "yes") {
		update_live_image();
		setTimeout('update_live_image_loop()', document.getElementById('live_image_auto_update_frequency').value*1000);
	}
}
function setCookie(c_name, value, expiredays) {
	var exdate = new Date();
	exdate.setDate(exdate.getDate() + expiredays);
	document.cookie = c_name + "=" + escape(value) + ((expiredays==null) ? "" : ";expires="+exdate.toGMTString());
}
function getCookie(c_name) {
	if (document.cookie.length>0) {
		c_start = document.cookie.indexOf(c_name + "=");
		if (c_start != -1) { 
			c_start = c_start + c_name.length + 1; 
			c_end = document.cookie.indexOf(";", c_start);
			if (c_end == -1)
				c_end = document.cookie.length;
			return unescape(document.cookie.substring(c_start, c_end));
		} 
	}
	return "";
}
function sel_all() {
	for(var i = 0; i < parameter_names.length; i++)
		document.getElementById(parameter_names[i]).checked = true;
}

function sel_none() {
	for(var i = 0; i < parameter_names.length; i++)
		document.getElementById(parameter_names[i]).checked = false;
}
function update_parameters() {
	makeRequest('preset_interface.php', '?cmd=update_parameters');
}
var ajax_binning_hor, ajax_binning_ver, ajax_dec_hor, ajax_dec_ver, ajax_mirror, ajax_bits, ajax_color, ajax_jpeg_qual, ajax_gain_r, ajax_gain_g, ajax_gain_b, ajax_gain_gb;
var ajax_scale_r, ajax_scale_g, ajax_scale_b, ajax_gamma, ajax_exposure, ajax_fps;

function process_update_parameters(xmldoc) {
	document.getElementById('ajax_woi_left').innerHTML = xmldoc.getElementsByTagName('ELPHEL_WOI_LEFT')[0].firstChild.data;
	document.getElementById('ajax_woi_top').innerHTML = xmldoc.getElementsByTagName('ELPHEL_WOI_TOP')[0].firstChild.data;
	document.getElementById('ajax_woi_width').innerHTML = xmldoc.getElementsByTagName('ELPHEL_WOI_WIDTH')[0].firstChild.data;
	document.getElementById('ajax_woi_height').innerHTML = xmldoc.getElementsByTagName('ELPHEL_WOI_HEIGHT')[0].firstChild.data;
	document.getElementById('ajax_binning_hor').innerHTML = "1:" + xmldoc.getElementsByTagName('ELPHEL_BIN_HOR')[0].firstChild.data;
	ajax_binning_hor = xmldoc.getElementsByTagName('ELPHEL_BIN_HOR')[0].firstChild.data;
	document.getElementById('ajax_binning_ver').innerHTML = "1:" + xmldoc.getElementsByTagName('ELPHEL_BIN_VERT')[0].firstChild.data;
	ajax_binning_ver = xmldoc.getElementsByTagName('ELPHEL_BIN_VERT')[0].firstChild.data
	document.getElementById('ajax_dec_hor').innerHTML = "1:" + xmldoc.getElementsByTagName('ELPHEL_DCM_HOR')[0].firstChild.data;
	ajax_dec_hor = xmldoc.getElementsByTagName('ELPHEL_DCM_HOR')[0].firstChild.data;
	document.getElementById('ajax_dec_ver').innerHTML = "1:" + xmldoc.getElementsByTagName('ELPHEL_DCM_VERT')[0].firstChild.data;
	ajax_dec_ver = xmldoc.getElementsByTagName('ELPHEL_DCM_VERT')[0].firstChild.data;
	document.getElementById('ajax_mirror').innerHTML = xmldoc.getElementsByTagName('ELPHEL_FLIP')[0].firstChild.data;
	ajax_mirror_v = xmldoc.getElementsByTagName('ELPHEL_FLIPV')[0].firstChild.data;
	ajax_mirror_h = xmldoc.getElementsByTagName('ELPHEL_FLIPH')[0].firstChild.data;	
	document.getElementById('ajax_color').innerHTML = xmldoc.getElementsByTagName('ELPHEL_COLOR')[0].firstChild.data;
	ajax_bits = xmldoc.getElementsByTagName('ELPHEL_BITS')[0].firstChild.data;
	ajax_color = xmldoc.getElementsByTagName('ELPHEL_CCOLOR')[0].firstChild.data;
	document.getElementById('ajax_jpeg_qual').innerHTML = xmldoc.getElementsByTagName('ELPHEL_QUALITY')[0].firstChild.data + " %";
	ajax_jpeg_qual = xmldoc.getElementsByTagName('ELPHEL_QUALITY')[0].firstChild.data;
	document.getElementById('ajax_gain_r').innerHTML = Math.round(xmldoc.getElementsByTagName('ELPHEL_GAINR')[0].firstChild.data / 65536 * 100, 0) + " %";
	document.getElementById('ajax_gain_g').innerHTML = Math.round(xmldoc.getElementsByTagName('ELPHEL_GAING')[0].firstChild.data / 65536 * 100, 0) + " %";
	document.getElementById('ajax_gain_b').innerHTML = Math.round(xmldoc.getElementsByTagName('ELPHEL_GAINB')[0].firstChild.data / 65536 * 100, 0) + " %";
	document.getElementById('ajax_gain_gb').innerHTML = Math.round(xmldoc.getElementsByTagName('ELPHEL_GAINGB')[0].firstChild.data / 65536 * 100, 0) + " %";
	ajax_gain_r = xmldoc.getElementsByTagName('ELPHEL_GAINR')[0].firstChild.data;
	ajax_gain_g = xmldoc.getElementsByTagName('ELPHEL_GAING')[0].firstChild.data;
	ajax_gain_b = xmldoc.getElementsByTagName('ELPHEL_GAINB')[0].firstChild.data;
	ajax_gain_gb = xmldoc.getElementsByTagName('ELPHEL_GAINGB')[0].firstChild.data;
	document.getElementById('ajax_scale_r').innerHTML = Math.round(xmldoc.getElementsByTagName('ELPHEL_RSCALE')[0].firstChild.data / 256 * 100, 0) + " %";
	document.getElementById('ajax_scale_g').innerHTML = Math.round(xmldoc.getElementsByTagName('ELPHEL_GSCALE')[0].firstChild.data / 256 * 100, 0) + " %";
	document.getElementById('ajax_scale_b').innerHTML = Math.round(xmldoc.getElementsByTagName('ELPHEL_BSCALE')[0].firstChild.data / 256 * 100, 0) + " %";
	ajax_scale_r = xmldoc.getElementsByTagName('ELPHEL_RSCALE')[0].firstChild.data;
	ajax_scale_g = xmldoc.getElementsByTagName('ELPHEL_GSCALE')[0].firstChild.data;	
	ajax_scale_b = xmldoc.getElementsByTagName('ELPHEL_BSCALE')[0].firstChild.data;	
	document.getElementById('ajax_gamma').innerHTML = xmldoc.getElementsByTagName('ELPHEL_GAMMA')[0].firstChild.data / 100;
	ajax_gamma = xmldoc.getElementsByTagName('ELPHEL_GAMMA')[0].firstChild.data;
	document.getElementById('ajax_black_level').innerHTML = xmldoc.getElementsByTagName('ELPHEL_PIXEL_LOW')[0].firstChild.data;	
	document.getElementById('ajax_white_level').innerHTML = xmldoc.getElementsByTagName('ELPHEL_PIXEL_HIGH')[0].firstChild.data;
	document.getElementById('ajax_sat_r').innerHTML = xmldoc.getElementsByTagName('ELPHEL_COLOR_SATURATION_RED')[0].firstChild.data;	
	document.getElementById('ajax_sat_b').innerHTML = xmldoc.getElementsByTagName('ELPHEL_COLOR_SATURATION_BLUE')[0].firstChild.data;
	document.getElementById('ajax_exposure').innerHTML = xmldoc.getElementsByTagName('ELPHEL_EXPOS')[0].firstChild.data / 10 + " ms";
	ajax_exposure = xmldoc.getElementsByTagName('ELPHEL_EXPOS')[0].firstChild.data ;
	document.getElementById('ajax_fps').innerHTML = xmldoc.getElementsByTagName('ELPHEL_FP1000S')[0].firstChild.data / 1000;
	ajax_fps = xmldoc.getElementsByTagName('ELPHEL_FP1000S')[0].firstChild.data;
}
function save_preset() {
	var parameter_list = "";
	parameter_list += "&preset_name=" + document.getElementById('preset_name').value;
	
	// nothing checked
	var changes = false;
	for(var i = 0; i< parameter_names.length; i++) {
		if (document.getElementById(parameter_names[i]).checked)
		changes = true;
	}
	if (!changes)
	{
		alert ("nothing selected! Saving preset aborted.");
		return;
	}

	if (document.getElementById('woi_left').checked)
		parameter_list += "&woi_left=" + document.getElementById('ajax_woi_left').innerHTML;
	if (document.getElementById('woi_top').checked)
		parameter_list += "&woi_top=" + document.getElementById('ajax_woi_top').innerHTML;
	if (document.getElementById('woi_width').checked)
		parameter_list += "&woi_width=" + document.getElementById('ajax_woi_width').innerHTML;
	if (document.getElementById('woi_height').checked)
		parameter_list += "&woi_height=" + document.getElementById('ajax_woi_height').innerHTML;
	if (document.getElementById('binning_hor').checked)
		parameter_list += "&binning_hor=" + ajax_binning_hor;
	if (document.getElementById('binning_ver').checked)
		parameter_list += "&binning_ver=" + ajax_binning_ver;	
	if (document.getElementById('dec_hor').checked)
		parameter_list += "&dec_hor=" + ajax_dec_hor;		
	if (document.getElementById('dec_ver').checked)
		parameter_list += "&dec_ver=" + ajax_dec_ver;	
	if (document.getElementById('mirror').checked)
	{
		parameter_list += "&flip_v=" + ajax_mirror_v;
		parameter_list += "&flip_h=" + ajax_mirror_h;
	}
	if (document.getElementById('color').checked)
		parameter_list += "&color=" + ajax_color;
	if (document.getElementById('color').checked)
		parameter_list += "&bits=" + ajax_bits;
	if (document.getElementById('jpeg_qual').checked)
		parameter_list += "&jpeg_qual=" + ajax_jpeg_qual;
	if (document.getElementById('gain_r').checked)
		parameter_list += "&gain_r=" + ajax_gain_r;
	if (document.getElementById('gain_g').checked)
		parameter_list += "&gain_g=" + ajax_gain_g;	
	if (document.getElementById('gain_b').checked)
		parameter_list += "&gain_b=" + ajax_gain_b;		
	if (document.getElementById('gain_gb').checked)
		parameter_list += "&gain_gb=" + ajax_gain_gb;	
	if (document.getElementById('scale_r').checked)
		parameter_list += "&scale_r=" + ajax_scale_r;	
	if (document.getElementById('scale_g').checked)
		parameter_list += "&scale_g=" + ajax_scale_g;	
	if (document.getElementById('scale_b').checked)
		parameter_list += "&scale_b=" + ajax_scale_b;	
	if (document.getElementById('gamma').checked)
		parameter_list += "&gamma=" + ajax_gamma;	
	if (document.getElementById('black_level').checked)
		parameter_list += "&black_level=" + document.getElementById('ajax_black_level').innerHTML;	
	if (document.getElementById('white_level').checked)
		parameter_list += "&white_level=" + document.getElementById('ajax_white_level').innerHTML;	
	if (document.getElementById('sat_r').checked)
		parameter_list += "&sat_r=" + document.getElementById('ajax_sat_r').innerHTML;	
	if (document.getElementById('sat_b').checked)
		parameter_list += "&sat_b=" + document.getElementById('ajax_sat_b').innerHTML;	
	if (document.getElementById('exposure').checked)
		parameter_list += "&exposure=" + ajax_exposure;	
	if (document.getElementById('fps').checked)
		parameter_list += "&fps=" + ajax_fps;		
		
	if (document.getElementById('preset_desc').value != "")
		parameter_list += "&desc=" + document.getElementById('preset_desc').value;		
			
	makeRequest('preset_interface.php', '?cmd=save_preset' + parameter_list);
	
	setTimeout('list_files("")', 300);
}

function load_preset(presetfile) {
	makeRequest('preset_interface.php', '?cmd=load_preset&preset_name=' + presetfile);
	setTimeout('update_parameters()', 200);	
}

